"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseArgs = exports.defaultFilters = void 0;
exports.defaultFilters = {
    upcase: (value) => value.toUpperCase(),
    downcase: (value) => value.toLowerCase(),
    capitalize: (value) => value.charAt(0).toUpperCase() + value.slice(1),
    toInt: (value) => parseInt(value),
    toFloat: (value) => parseFloat(value),
    toString: (value) => value.toString(),
};
const QUOTED_STRING_REGEX = /^(["'])(?<string>.+)\1$/;
const splitPattern = /,(?![^{}]*})/g;
const parseArgs = (args) => args.length > 0
    ? args
        .split(splitPattern)
        .map((arg) => arg.trim())
        .map((arg) => QUOTED_STRING_REGEX.test(arg) ? arg.slice(1, -1) : JSON.parse(arg))
    : [];
exports.parseArgs = parseArgs;
